import { useEffect, useRef, useState } from 'react'
import { useDispatch } from 'react-redux'
import { setQuery } from './app/searchSlice'
import { setShowName } from './app/displaySlice'
import { IconList } from './IconList'
// import './App.css'

function App() {
	const inputSearch = useRef()
	const checkShowName = useRef()
	const dispatch = useDispatch()
	const [currentQuery, setCurrentQuery] = useState("")

	function queryOnChange () {
		let query = inputSearch.current.value
		query = query.replace(/[^a-zA-Z0-9\- ]/, "")
		setCurrentQuery(query)
		dispatch(setQuery(query))
	}

	function showNameOnChange () {
		dispatch(setShowName(checkShowName.current.checked))
	}

	useEffect(() => {
		inputSearch.current.focus()
	})

	return (
		<>
			<div className="pixel-input">
				<input type='text' id='search' ref={ inputSearch } onChange={ queryOnChange } value={ currentQuery } placeholder="Search an icon — try 'animal', 'fruit', 'logo', 'ui' or 'red'" autoComplete='no' />
			</div>
			<div id='display-options'>
				<input type="checkbox" name="checkShowName" ref={ checkShowName } onChange={ showNameOnChange } id='checkShowName' />
				<label htmlFor="checkShowName">Display icon names</label>
			</div>
			<IconList></IconList>
		</>
	)
}

export default App
